﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace GROESTL
{
    public class Konstruktor
    {
        public int brojKoraka;
        public int BrojStupaca;
        List<int> Shift = new List<int>();
        public int[] poljeZaShift;
        public string oznaka;

        public Konstruktor(int brojKoraka, int BrojStupaca, int[] polje, string oznaka)
        {
            this.brojKoraka = brojKoraka;
            this.BrojStupaca = BrojStupaca;
            this.oznaka = oznaka;

            foreach (int element in polje)
            {
                Shift.Add(element);
            }
            this.poljeZaShift = Shift.ToArray();
        }
    }


    public class RadSPermutacijama
    {

        Konstruktor ZaP512 = new Konstruktor(10, 8, P512, "P");
        Konstruktor ZaP1024 = new Konstruktor(14, 16, P1024, "P");
        Konstruktor ZaQ512 = new Konstruktor(10, 8, Q512, "Q");
        Konstruktor ZaQ1024 = new Konstruktor(14, 16, Q1024, "Q");

        // public class Constants
        //{
        /* byte[,] S_Kutija = {{0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76},
                             {0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0},
                             {0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15},
                             {0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75},
                             {0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84},
                             {0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf},
                             {0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8},
                             {0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2},
                             {0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73},
                             {0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb},
                             {0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79},
                             {0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08},
                             {0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a},
                             {0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e},
                             {0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf},
                             {0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16}};*/
        byte[] S_Kutija = {0x63, 0x7C, 0x77, 0x7B, 0xF2, 0x6B, 0x6F, 0xC5, 0x30, 0x01, 0x67, 0x2B, 0xFE, 0xD7, 0xAB, 0x76,
                            0xCA, 0x82, 0xC9, 0x7D, 0xFA, 0x59, 0x47, 0xF0, 0xAD, 0xD4, 0xA2, 0xAF, 0x9C, 0xA4, 0x72, 0xC0,
                            0xB7, 0xFD, 0x93, 0x26, 0x36, 0x3F, 0xF7, 0xCC, 0x34, 0xA5, 0xE5, 0xF1, 0x71, 0xD8, 0x31, 0x15,
                            0x04, 0xC7, 0x23, 0xC3, 0x18, 0x96, 0x05, 0x9A, 0x07, 0x12, 0x80, 0xE2, 0xEB, 0x27, 0xB2, 0x75,
                            0x09, 0x83, 0x2C, 0x1A, 0x1B, 0x6E, 0x5A, 0xA0, 0x52, 0x3B, 0xD6, 0xB3, 0x29, 0xE3, 0x2F, 0x84,
                            0x53, 0xD1, 0x00, 0xED, 0x20, 0xFC, 0xB1, 0x5B, 0x6A, 0xCB, 0xBE, 0x39, 0x4A, 0x4C, 0x58, 0xCF,
                            0xD0, 0xEF, 0xAA, 0xFB, 0x43, 0x4D, 0x33, 0x85, 0x45, 0xF9, 0x02, 0x7F, 0x50, 0x3C, 0x9F, 0xA8,
                            0x51, 0xA3, 0x40, 0x8F, 0x92, 0x9D, 0x38, 0xF5, 0xBC, 0xB6, 0xDA, 0x21, 0x10, 0xFF, 0xF3, 0xD2,
                            0xCD, 0x0C, 0x13, 0xEC, 0x5F, 0x97, 0x44, 0x17, 0xC4, 0xA7, 0x7E, 0x3D, 0x64, 0x5D, 0x19, 0x73,
                            0x60, 0x81, 0x4F, 0xDC, 0x22, 0x2A, 0x90, 0x88, 0x46, 0xEE, 0xB8, 0x14, 0xDE, 0x5E, 0x0B, 0xDB,
                            0xE0, 0x32, 0x3A, 0x0A, 0x49, 0x06, 0x24, 0x5C, 0xC2, 0xD3, 0xAC, 0x62, 0x91, 0x95, 0xE4, 0x79,
                            0xE7, 0xC8, 0x37, 0x6D, 0x8D, 0xD5, 0x4E, 0xA9, 0x6C, 0x56, 0xf4, 0xEA, 0x65, 0x7A, 0xAE, 0x08,
                            0xBA, 0x78, 0x25, 0x2E, 0x1C, 0xA6, 0xB4, 0xC6, 0xE8, 0xDD, 0x74, 0x1F, 0x4B, 0xBD, 0x8B, 0x8A,
                            0x70, 0x3E, 0xB5, 0x66, 0x48, 0x03, 0xF6, 0x0E, 0x61, 0x35, 0x57, 0xB9, 0x86, 0xC1, 0x1D, 0x9E,
                            0xE1, 0xF8, 0x98, 0x11, 0x69, 0xD9, 0x8E, 0x94, 0x9B, 0x1E, 0x87, 0xE9, 0xCE, 0x55, 0x28, 0xDF,
                            0x8C, 0xA1, 0x89, 0x0D, 0xBF, 0xE6, 0x42, 0x68, 0x41, 0x99, 0x2D, 0x0F, 0xB0, 0x54, 0xBB, 0x16};


        static int[] P512 = { 0, 1, 2, 3, 4, 5, 6, 7 };
        static int[] P1024 = { 0, 1, 2, 3, 4, 5, 6, 11 };
        static int[] Q512 = { 1, 3, 5, 7, 0, 2, 4, 6 };
        static int[] Q1024 = { 1, 3, 5, 11, 0, 2, 4, 6 };

        //Konstruktor ZaP512 = new Konstruktor(10, 8, Constants.P512, "P");
        //Konstruktor ZaP1024 = new Konstruktor(14, 16, Constants.P1024, "P");
        //Konstruktor ZaQ512 = new Konstruktor(10, 8, Constants.Q512, "Q");
        //Konstruktor ZaQ1024 = new Konstruktor(14, 16, Constants.Q1024, "Q");

        byte[,] P512Tablica = { {0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70}, 
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};

        byte[,] P1024Tablica = {{0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70, 0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0, 0xf0},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
                                    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};

        byte[,] Q512Tablica = { {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xef, 0xdf, 0xcf, 0xbf, 0xaf, 0x9f, 0x8f}};

        byte[,] Q1024Tablica = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
                                    {0xff, 0xef, 0xdf, 0xcf, 0xbf, 0xaf, 0x9f, 0x8f, 0x7f, 0x6f, 0x5f, 0x4f, 0x3f, 0x2f, 0x1f, 0x0f}};



        public static byte mul1(byte b)
        {
            return (byte)(b);
        }

        public static byte mul2(byte b)
        {
            if ((b >> 7) != -1)
                return (byte)((b << 1) ^ 0x1B);
            else
                return (byte)(b << 1);
        }

        public static byte mul3(byte b)
        {
            byte m = (byte)(mul2(b) ^ mul1(b));
            return m;
        }

        public static byte mul4(byte b)
        {
            return (byte)(mul2(mul2(b)));
        }

        public static byte mul5(byte b)
        {
            return (byte)(mul4(b) ^ (mul1(b)));
        }

        public static byte mul6(byte b)
        {
            return (byte)(mul4(b) ^ mul2(b));
        }

        public static byte mul7(byte b)
        {
            return (byte)(mul4(b) ^ mul2(b) ^ mul1(b));
        }

        public byte[] PermutacijaP(byte[] input, byte[] output, int duljina)
        {

            if (duljina == 512)
                output = IzvrsiPermutacije(input, output, ZaP512);
            else
                output = IzvrsiPermutacije(input, output, ZaP1024);

            return output;
        }


        public byte[] PermutacijaQ(byte[] input, byte[] output, int duljina)
        {
            if (duljina == 512)
                output = IzvrsiPermutacije(input, output, ZaQ512);
            else
                output = IzvrsiPermutacije(input, output, ZaQ1024);

            return output;
        }


        public byte[] IzvrsiPermutacije(byte[] input, byte[] output, Konstruktor P)
        {
            //byte[] izlazak = new byte[8 * broj];
            int[] poljeZaShiftanje = P.poljeZaShift;
            int broj = P.BrojStupaca;
            int Korak = P.brojKoraka;
            string oznaka = P.oznaka;
            byte[,] UlaznaMatrica = new byte[8, broj];

            /* Console.WriteLine("Ovo je duljina");
             Console.WriteLine(input.Length);
             */

            for (int i = 0; i < 8; i++)
                for (int j = 0; j < broj; j++)
                {
                    //Console.WriteLine(input[8 * j + i]);
                    UlaznaMatrica[i, j] = input[8 * j + i];
                }
            for (int i = 0; i < Korak; i++)
            {
                if ((broj == 8) && (oznaka.Equals("P")))
                    UlaznaMatrica = AddRoundConstantZaP512(i, UlaznaMatrica, broj);
                else if ((broj == 16) && (oznaka.Equals("P")))
                    UlaznaMatrica = AddRoundConstantZaP1024(i, UlaznaMatrica, broj);
                else if ((broj == 8) && (oznaka.Equals("Q")))
                    UlaznaMatrica = AddRoundConstantZaQ512(i, UlaznaMatrica, broj);
                else
                    UlaznaMatrica = AddRoundConstantZaQ1024(i, UlaznaMatrica, broj);
                UlaznaMatrica = OstaleTransformacije(broj, UlaznaMatrica, poljeZaShiftanje);
            }

            for (int i = 0; i < 8; i++)
                for (int j = 0; j < P.BrojStupaca; j++)
                {
                    //Console.WriteLine(UlaznaMatrica[i,j]);

                    output[8 * j + i] = UlaznaMatrica[i, j];//baca gresku
                }

            /* for (int i = 0; i < izlazak.Length; i++) 
                     Console.WriteLine(izlazak[i]);
             */

            return output;
        }


        public byte[,] AddRoundConstantZaP512(int i, byte[,] matrica, int Stupac)
        {
            for (int j = 0; j < Stupac; j++)
                matrica[0, j] = (byte)(matrica[0, j] ^ (j << 4) ^ i);
            return matrica;
        }

        public byte[,] AddRoundConstantZaQ512(int l, byte[,] matrica, int Stupac)
        {
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < Stupac; j++)
                {
                    if (i != 7)
                        matrica[i, j] = (byte)(matrica[i, j] ^ 0xFF);
                    else
                        matrica[i, j] = (byte)(matrica[i, j] ^ (0x0F | ((0x0F - j) << 4)) ^ l);
                }
            }
            return matrica;
        }

        public byte[,] AddRoundConstantZaQ1024(int l, byte[,] matrica, int Stupac)
        {
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < Stupac; j++)
                {
                    if (i != 7)
                        matrica[i, j] = (byte)(matrica[i, j] ^ 0xFF);
                    else
                        matrica[i, j] = (byte)(matrica[i, j] ^ (0x0F | ((0x0F - j) << 4)) ^ l);
                }
            }
            return matrica;
        }

        public byte[,] AddRoundConstantZaP1024(int i, byte[,] matrica, int Stupac)
        {
            for (int j = 0; j < Stupac; j++)
                matrica[0, j] = (byte)(matrica[0, j] ^ (j << 4) ^ i);

            return matrica;
        }


        public byte[,] OstaleTransformacije(int Stupac, byte[,] matrica, int[] polje)
        {
            byte[] array = new byte[Stupac];

            for (int i = 0; i < 8; i++)
                for (int j = 0; j < Stupac; j++)
                {
                    // matrica[i, j] = S_Kutija[((byte)(matrica[i, j] & 0xf0)) >> 4, matrica[i, j] & 0x0f]; ovo ne radi

                    matrica[i, j] = S_Kutija[matrica[i, j]];

                    //Console.WriteLine(matrica[i, j]);

                }

            for (int k = 0; k < 8; k++)
            {
                for (int l = 0; l < Stupac; l++)
                {
                    array[l] = matrica[k, (l + polje[k]) % Stupac];
                }
                for (int l = 0; l < Stupac; l++)
                    matrica[k, l] = array[l];
            }

            for (int j = 0; j < Stupac; ++j)
            {
                for (int i = 0; i < 8; ++i)
                    array[i] = (byte)(mul2(matrica[i, j]) ^ mul2(matrica[(i + 1) % 8, j]) ^ mul3(matrica[(i + 2) % 8, j]) ^ mul4(matrica[(i + 3) % 8, j]) ^ mul5(matrica[(i + 4) % 8, j]) ^ mul3(matrica[(i + 5) % 8, j]) ^ mul5(matrica[(i + 6) % 8, j]) ^ mul7(matrica[(i + 7) % 8, j]));
                for (int i = 0; i < 8; ++i)
                    matrica[i, j] = array[i];
            }
            return matrica;
        }
    }

}
